package com.huimv.cattle.config;

import com.alibaba.fastjson.JSONObject;
import com.huimv.common.token.TokenConstant;
import com.huimv.common.token.TokenSign;
import io.jsonwebtoken.Claims;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.web.method.HandlerMethod;
import org.springframework.web.servlet.HandlerInterceptor;
import org.springframework.web.servlet.ModelAndView;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Map;

/**
 * @Project : huimv-breed
 * @Package : IntelliJ IDEA
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2022/9/28
 **/
@Slf4j
public class GlobalInterceptor implements HandlerInterceptor {
//    @Resource(name="redisUUID_common")
//    private RedisUUID redisUUID;

    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object obj) throws Exception {
        String secreKey = request.getHeader("from");
//        System.out.println("判断是否直连服务 secreKey="+secreKey);
//        if (!StringUtils.isNotBlank(secreKey) || secreKey.equals(redisUUID.get("from"))) {
//            response.setContentType("application/json; charset=utf-8");
//            PrintWriter writer = response.getWriter();
//            writer.write("不能直连服务接口,必须请求gateway网关转发.");
//            return false;
//        }
        System.out.println(secreKey);
        //        return true;
        //token验证
        if (!(obj instanceof HandlerMethod)) {
            return true;
        } else {
            response.setContentType("application/json;charset=utf-8");
            String token = request.getHeader("accessToken");
            System.out.println(token);
            if (StringUtils.isBlank(token) ) {
                Map<String, Object> map = new HashMap();
                map.put("data", "token is null");
                map.put("code", "401");
                response.setStatus(401);
                response.getWriter().write(JSONObject.toJSONString(map));
                return false;
            } else {
                Claims claims = TokenSign.getClaims(token);
                if (claims == null) {
                    Map<String, Object> map = new HashMap();
                    map.put("data", "token is overdue");
                    map.put("code", "403");
                    response.setStatus(403);
                    response.getWriter().write(JSONObject.toJSONString(map));
                    return false;
                } else {
                    boolean result = TokenSign.verify(token);
                    if (result) {
                        TokenConstant.updateTokenMap(token);
                        return true;
                    } else {
                        Map<String, Object> map = new HashMap();
                        map.put("data", "token is null");
                        map.put("code", "401");
                        response.setStatus(401);
                        response.getWriter().write(JSONObject.toJSONString(map));
                        return false;
                    }
                }
            }
        }
    }

    //    @Override
//    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object obj) throws Exception {
//        long exist =  authIgnoreConfig.getIgnoreUrls().stream().filter(url-> url.trim().equals(request.getRequestURI())).count();
//        if(exist != 0){
//            return true;
//        }
//        String secretKey = request.getHeader(Const.SECRET_KEY);
//        if(StringUtils.isNotBlank(secretKey)){
//            String key = (String) redisUUID.get(Const.SECRET_KEY);
//            if(!StringUtils.isBlank(key) && secretKey.equals(key)){
//                return true;
//            }
//        }
//        response.setContentType("application/json; charset=utf-8");
//        PrintWriter writer = response.getWriter();
//        writer.write(JSONUtil.toJsonStr(R.error("illegal request")));
//        return false;
//    }

    @Override
    public void postHandle(HttpServletRequest request, HttpServletResponse response, Object handler, ModelAndView modelAndView) throws Exception {

    }

    @Override
    public void afterCompletion(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex) throws Exception {

    }

}
