package com.huimv.cattle.controller;


import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.cattle.pojo.Insure;
import com.huimv.cattle.pojo.VaccineDelivery;
import com.huimv.cattle.pojo.vo.InsureVo;
import com.huimv.cattle.service.InsureService;
import com.huimv.cattle.utils.FarmCodeUtils;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zn
 * @since 2022-12-15
 */
@CrossOrigin
@RestController
@RequestMapping("/v1.0.0/insure")
public class InsureController {
    @Autowired
    private InsureService insureService;

    @PostMapping("/saveInsure")
    public Result add(@RequestBody Insure insure , HttpServletRequest request){
        String farmCode = FarmCodeUtils.getFarmCode(insure.getFarmCode(), request);
        insure.setFarmCode(farmCode);
        insureService.save(insure);
        return new Result(10000,"添加成功",true);
    }
    @PostMapping("/updateInsure")
    public  Result update(@RequestBody Insure insure){
        insureService.updateById(insure);
        return new Result(10000,"修改成功",true);
    }
    @PostMapping("/deleteInsure")
    public  Result delete(@RequestBody Map<String,String> paramMap){
        String ids = paramMap.get("ids");
        String[] split = ids.split(",");
        for (String s : split) {
            insureService.removeById(s);
        }
        return new Result(10000,"删除成功",true);
    }
    @PostMapping("/getInsure")
    public  Result getInsure(@RequestBody Insure insure, HttpServletRequest request){
        String farmCode = FarmCodeUtils.getFarmCode(insure.getFarmCode(), request);
        List<Insure> list = insureService.list(new QueryWrapper<Insure>().eq("farm_code",farmCode).orderByDesc("insurance_time"));
        if (ObjectUtil.isEmpty(list)){
            return new Result(ResultCode.SUCCESS,new ArrayList<>());
        }
        return new Result(ResultCode.SUCCESS,list);
    }

}

