package com.huimv.cattle.controller;


import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.cattle.pojo.Supervise;
import com.huimv.cattle.pojo.VaccineDelivery;
import com.huimv.cattle.service.SuperviseService;
import com.huimv.cattle.utils.FarmCodeUtils;
import com.huimv.cattle.utils.SuperServiseUtils;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zn
 * @since 2022-12-15
 */
@CrossOrigin
@RestController
@RequestMapping("/v1.0.0/supervise")
public class SuperviseController {

    @Autowired
    private SuperviseService superviseService;

    @PostMapping("/saveSupervise")
    @Transactional
    public Result add(@RequestBody Map<String,String> paramMap, HttpServletRequest request){
        String farmCode = FarmCodeUtils.getFarmCode(paramMap.get("farmCode"), request);
        superviseService.remove(new QueryWrapper<Supervise>().eq("farm_code", farmCode));
        for (String key : paramMap.keySet()) {
            String value = paramMap.get(key);
            Supervise supervise = new Supervise();
            supervise.setSuperviseCode(key);
            supervise.setSuperviseName(SuperServiseUtils.getSuperServise(key));
            supervise.setSuperviseData(value);
            supervise.setFarmCode(farmCode);
            superviseService.save(supervise);
        }
        return new Result(10000,"添加成功",true);
    }

    @PostMapping("/updateSupervise")
    public  Result update(@RequestBody Supervise supervise){
        superviseService.updateById(supervise);
        return new Result(10000,"修改成功",true);
    }
    @PostMapping("/deleteSupervise")
    public  Result delete(@RequestBody Map<String,String> paramMap){
        String ids = paramMap.get("ids");
        String[] split = ids.split(",");
        for (String s : split) {
            superviseService.removeById(s);
        }
        return new Result(10000,"删除成功",true);
    }
    @PostMapping("/getSupervise")
    public  Result list(@RequestBody Supervise supervise, HttpServletRequest request){
        String farmCode = FarmCodeUtils.getFarmCode(supervise.getFarmCode(),   request);
        return   superviseService.getSupervise(farmCode);
    }

}

