package com.huimv.cattle.controller;


import com.huimv.cattle.service.SysFarmService;
import com.huimv.common.utils.Result;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zn
 * @since 2022-09-26
 */
@CrossOrigin
@RestController
@RequestMapping("/platform/v1.0.0/farm")
public class SysFarmController {
    @Resource
    private SysFarmService sysFarmService;

    /**
     * @Method      : initFarm
     * @Description : 初始化牧场
     * @Params      : [request, paramsMap]
     * @Return      : com.huimv.common.utils.Result
     *
     * @Author      : ZhuoNing
     * @Date        : 2022/10/9
     * @Time        : 16:47
     */
    @PostMapping("/initFarm")
    public Result initFarm(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return sysFarmService.initFarmFlow(request,paramsMap);
    }

    @PostMapping("/list")
    public Result listFarm(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return sysFarmService.listFarm(request,paramsMap);
    }

    @PostMapping("/getAllFarmId")
    public Result getAllFarms(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return sysFarmService.getAllFarmId(request,paramsMap);
    }

    @PostMapping("/new")
    public Result newFarm(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return sysFarmService.newFarm(request,paramsMap);
    }

    @PostMapping("/edit")
    public Result editFarm(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return sysFarmService.editFarm(request,paramsMap);
    }

    @PostMapping("/remove")
    public Result remove(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return sysFarmService.removeFarm(request,paramsMap);
    }

    @PostMapping("/password/reset")
    public Result resetPassword(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return sysFarmService.resetPassword(request,paramsMap);
    }

    @PostMapping("/listAllTownsCount")
    public Result listAllTownsCount(HttpServletRequest request){
        return sysFarmService.listAllTownsCount(request);
    }
}

