package com.huimv.cattle.controller;


import cn.hutool.core.util.ObjectUtil;
import com.huimv.cattle.service.SysMenuService;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zn
 * @since 2022-09-26
 */
@CrossOrigin
@RestController
@RequestMapping("/v1.0.0/menu")
public class SysMenuController {
    @Resource
    private SysMenuService sysMenuService;

    @PostMapping("/list")
    public Result list(@RequestBody Map<String,String> paramMap){
        return sysMenuService.list(paramMap);
    }

    @PostMapping("/getMyMenu")
    public Result listMyMenu(HttpServletRequest request, @RequestBody Map<String,String> paramMap){
        return sysMenuService.getMyMenu(request,paramMap);
    }

    @PostMapping("/new")
    public Result newMenu(@RequestBody Map<String,String> paramMap){
        return sysMenuService.newMenu(paramMap);
    }

    @PostMapping("/edit")
    public Result editMenu(@RequestBody Map<String,String> paramMap){
        return sysMenuService.editMenu(paramMap);
    }

    @PostMapping("/remove")
    public Result removeMenu(@RequestBody Map<String,String> paramMap){
        return sysMenuService.removeMenu(paramMap);
    }

    @PostMapping("/getMyButton")
    public Result getMyButton(HttpServletRequest request, @RequestBody Map<String, String> paramMap) {
        List<String> myButton = sysMenuService.getMyButton(request, paramMap);
        if (ObjectUtil.isNotEmpty(myButton)){
            return new Result(ResultCode.SUCCESS,myButton);
        }else {
            return new Result(ResultCode.FAIL,myButton);
        }
    }

}

