package com.huimv.cattle.controller;


import com.huimv.cattle.service.SysUserAccountService;
import com.huimv.common.utils.Result;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.text.ParseException;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zn
 * @since 2022-09-26
 */
@CrossOrigin
@RestController
@RequestMapping("/v1.0.0/account")
public class SysUserAccountController {
    @Resource
    private SysUserAccountService sysUserAccountService;

    @PostMapping("/login")
    public Result login(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
       return sysUserAccountService.login(request,paramsMap);
    }
    @PostMapping("/loginApp")
    public Result loginApp(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return sysUserAccountService.loginApp(request,paramsMap);
    }

    @PostMapping("/loginScreen")
    public Result loginScreen(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return sysUserAccountService.loginScreen(request,paramsMap);
    }
    @PostMapping("/logout")
    public Result logout(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
//        return sysUserAccountService.logout(request,paramsMap);
        return null;
//        return new Result(ResultCode.SUCCESS,null);
    }

    /**
     * @Method      : newUserAccount
     * @Description : 新建账户
     * @Params      : [request, paramsMap]
     * @Return      : com.huimv.common.utils.Result
     *
     * @Author      : ZhuoNing
     * @Date        : 2022/10/9
     * @Time        : 16:47
     */
    @PostMapping("/new")
    public Result newUserAccount(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return sysUserAccountService.newUserAccount(request,paramsMap);
    }

    /**
     * @Method      : editUserAccount
     * @Description : 编辑账户
     * @Params      : [request, paramsMap]
     * @Return      : com.huimv.common.utils.Result
     *
     * @Author      : ZhuoNing
     * @Date        : 2022/10/9
     * @Time        : 16:47
     */
    @PostMapping("/edit")
    public Result editUserAccount(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return sysUserAccountService.editUserAccount(paramsMap);
    }

    /**
     * @Method      : removeUserAccount
     * @Description : 删除账户
     * @Params      : [request, paramsMap]
     * @Return      : com.huimv.common.utils.Result
     *
     * @Author      : ZhuoNing
     * @Date        : 2022/10/9
     * @Time        : 16:47
     */
    @PostMapping("/remove")
    public Result removeUserAccount(HttpServletRequest request, @RequestBody Map<String, String> paramsMap){
        return sysUserAccountService.removeUserAccount(paramsMap);
    }

    /**
     * @Method      : listUserAccount
     * @Description : 列表展示账户
     * @Params      : [request, paramsMap]
     * @Return      : com.huimv.common.utils.Result
     * 
     * @Author      : ZhuoNing
     * @Date        : 2022/10/9       
     * @Time        : 16:47
     */
    @PostMapping("/list")
    public Result listUserAccount(HttpServletRequest request, @RequestBody Map<String, String> paramsMap) throws ParseException {
        return sysUserAccountService.listUserAccount(request,paramsMap);
    }

    /**
     * @Method      : listPlatformUserAndFarmAdmin
     * @Description : 显示平台账号和牧场管理员两类账户信息
     * @Params      : [request, paramsMap]
     * @Return      : com.huimv.common.utils.Result
     * 
     * @Author      : ZhuoNing
     * @Date        : 2022/10/13       
     * @Time        : 19:48
     */
    @PostMapping("/listPlatformUserAndFarmAdmin")
    public Result listPlatformUserAndFarmAdmin(HttpServletRequest request, @RequestBody Map<String, String> paramsMap) throws ParseException {
        return sysUserAccountService.listPlatformUserAndFarmAdmin(request,paramsMap);
    }

    @PostMapping("/password/reset")
    public Result resetPassword(HttpServletRequest request, @RequestBody Map<String, String> paramsMap) throws ParseException {
        return sysUserAccountService.resetPassword(paramsMap);
    }

    @PostMapping("/resetMyPassword")
    public Result resetMyPassword(HttpServletRequest request, @RequestBody Map<String, String> paramsMap) throws ParseException {
        return sysUserAccountService.resetMyPassword(request,paramsMap);
    }
}

