package com.huimv.cattle.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.cattle.pojo.FarmStockRank;
import com.huimv.cattle.mapper.FarmStockRankMapper;
import com.huimv.cattle.service.FarmStockRankService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.xml.ws.Action;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zn
 * @since 2022-12-15
 */
@Service
public class FarmStockRankServiceImpl extends ServiceImpl<FarmStockRankMapper, FarmStockRank> implements FarmStockRankService {

    @Autowired
    private FarmStockRankMapper farmStockRankMapper;
    @Override
    public Result getFarmStockRank(String farmCode) {
        List<FarmStockRank> list = farmStockRankMapper.selectList(new QueryWrapper<FarmStockRank>().eq("farm_code",farmCode).orderByDesc("stock"));
        if (ObjectUtil.isEmpty(list)){
            return new Result(ResultCode.SUCCESS,new ArrayList<>());
        }
        return new Result(ResultCode.SUCCESS,list);
    }
}
