package com.huimv.cattle.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.cattle.pojo.SalesCattle;
import com.huimv.cattle.mapper.SalesCattleMapper;
import com.huimv.cattle.service.SalesCattleService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zn
 * @since 2022-12-15
 */
@Service
public class SalesCattleServiceImpl extends ServiceImpl<SalesCattleMapper, SalesCattle> implements SalesCattleService {
    @Autowired
    private SalesCattleMapper salesCattleMapper;

    @Override
    public Result getSalesCattle(String farmCode) {
        List<SalesCattle> list = salesCattleMapper.selectList(new QueryWrapper<SalesCattle>().eq("farm_code",farmCode).orderByDesc("year").orderByDesc("quarter"));
        if (ObjectUtil.isEmpty(list)){
            return new Result(ResultCode.SUCCESS,new ArrayList<>());
        }
        return new Result(ResultCode.SUCCESS,list);
    }

    @Override
    public Result getAllSaleCattle(String farmCode) {
//        QueryWrapper<SalesCattle> wrapper = new QueryWrapper<SalesCattle>().orderByDesc("year").orderByDesc("quarter").groupBy("year ").groupBy("quarter");
//        List<SalesCattle> list = salesCattleMapper.geaAllSaleCattle(wrapper);
        QueryWrapper<SalesCattle> wrapper = new QueryWrapper<SalesCattle>();
        wrapper.eq("farm_code",farmCode).orderByDesc("year").orderByDesc("quarter");
        List<SalesCattle> list = salesCattleMapper.selectList(wrapper);
        if (ObjectUtil.isEmpty(list)){
            return new Result(ResultCode.SUCCESS,new ArrayList<>());
        }
        return new Result(ResultCode.SUCCESS,list);
    }
    @Override
    public Result getSalesCattleScreen() {
        QueryWrapper<SalesCattle> wrapper = new QueryWrapper<SalesCattle>().ne("farm_code",0).orderByDesc("year").orderByDesc("quarter").groupBy("year ").groupBy("quarter");
        List<SalesCattle> list = salesCattleMapper.geaAllSaleCattle(wrapper);
        if (ObjectUtil.isEmpty(list)){
            return new Result(ResultCode.SUCCESS,new ArrayList<>());
        }
        return new Result(ResultCode.SUCCESS,list);
    }
}
