package com.huimv.cattle.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.cattle.pojo.Supervise;
import com.huimv.cattle.mapper.SuperviseMapper;
import com.huimv.cattle.service.SuperviseService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zn
 * @since 2022-12-15
 */
@Service
public class SuperviseServiceImpl extends ServiceImpl<SuperviseMapper, Supervise> implements SuperviseService {

    @Autowired
    private SuperviseMapper superviseMapper;
    @Override
    public Result getSupervise(String farmCode) {
        Map map = new HashMap();
        map.put("ZCL",superviseGatValue(farmCode ,"ZCL"));
        map.put("ZCLCL",superviseGatValue(farmCode ,"ZCLCL"));
        map.put("HZNH",superviseGatValue(farmCode ,"HZNH"));
        map.put("LJFFNL",superviseGatValue(farmCode ,"LJFFNL"));
        map.put("KCLSL",superviseGatValue(farmCode ,"KCLSL"));
        map.put("CLCL",superviseGatValue(farmCode ,"CLCL"));
        map.put("CLML",superviseGatValue(farmCode ,"CLML"));
        map.put("WCLSL",superviseGatValue(farmCode ,"WCLSL"));
        map.put("NCUL",superviseGatValue(farmCode ,"NCUL"));
        map.put("FWXC",superviseGatValue(farmCode ,"FWXC"));
        map.put("NMZS",superviseGatValue(farmCode ,"NMZS"));
        map.put("QYZS",superviseGatValue(farmCode ,"QYZS"));
        return new Result(ResultCode.SUCCESS,map);
    }

    private String superviseGatValue(String farmCode,String key) {
        QueryWrapper<Supervise> wrapper = new QueryWrapper<>();
        wrapper.eq("farm_code",farmCode);
        wrapper.eq("supervise_code",key);
        Supervise supervise = superviseMapper.selectOne(wrapper);
        if (ObjectUtil.isEmpty(supervise)){
            return "0";
        }else {
            return supervise.getSuperviseData();
        }
    }

}
