package com.huimv.cattle.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
//import com.huimv.breed.common.utils.ConstUtil;
//import com.huimv.breed.common.utils.ResultUtil;
import com.huimv.cattle.mapper.SysUserGroupMapper;
import com.huimv.cattle.pojo.SysUserGroup;
import com.huimv.cattle.service.SysUserGroupService;
import com.huimv.cattle.utils.ConstUtil;
import com.huimv.cattle.utils.ResultUtil;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
//import com.huimv.saas.admin.mapper.SysUserGroupMapper;
//import com.huimv.saas.admin.pojo.SysUserGroup;
//import com.huimv.saas.admin.service.SysUserGroupService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author zn
 * @since 2022-09-26
 */
@Service
public class SysUserGroupServiceImpl extends ServiceImpl<SysUserGroupMapper, SysUserGroup> implements SysUserGroupService {
    @Resource
    private SysUserGroupMapper sysUserGroupMapper;
    @Resource
    private ResultUtil resultUtil;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Result saveUserGroup(Map<String, String> paramsMap) {
        String userId = paramsMap.get("userId");
        String groupIds = paramsMap.get("groupIds");
        //-- 删除权限组绑定才菜单 --//
        QueryWrapper<SysUserGroup> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(StringUtils.isNotBlank(userId), "user_id", userId);
        sysUserGroupMapper.delete(queryWrapper);
        //-- 新增用户绑定权限组 --//
        String[] groupIdArray = groupIds.split(",");
        int rows = 0;
        for (int a = 0; a < groupIdArray.length; a++) {
            SysUserGroup newSysUserGroup = new SysUserGroup();
            newSysUserGroup.setUserId(Integer.parseInt(userId));
            newSysUserGroup.setGroupId(Integer.parseInt(groupIdArray[a]));
            rows += sysUserGroupMapper.insert(newSysUserGroup);
        }
        return resultUtil.getResult(rows);
    }

    /**
     * @Method      : getGroupByUserId
     * @Description : 根据用户获取权限组
     * @Params      : [paramsMap]
     * @Return      : com.huimv.common.utils.Result
     * 
     * @Author      : ZhuoNing
     * @Date        : 2022/10/10       
     * @Time        : 13:55
     */
    @Override
    public Result getGroupByUserId(Map<String, String> paramsMap) {
        String userId = paramsMap.get("userId");
        QueryWrapper<SysUserGroup> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(StringUtils.isNotBlank(userId), "user_id", userId);
        List<SysUserGroup> sysUserGroupList = sysUserGroupMapper.selectList(queryWrapper);
        if(sysUserGroupList.size() == 0){
            return new Result(ConstUtil.ERR_MYGROUP_EMPTY_CODE,ConstUtil.ERR_MYGROUP_EMPTY_INFO,false);
        }
        return new Result(ResultCode.SUCCESS,sysUserGroupList);
    }
}
