package com.huimv.cattle.utils;

import cn.hutool.core.date.DateTime;
import org.springframework.stereotype.Component;

import java.sql.Timestamp;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Component
//@Slf4j
public class DateUtil {

    public int getIntervalDays(String startDate,String endDate) throws ParseException {
        DateFormat dft = new SimpleDateFormat("yyyy-MM-dd");
        Date starDay = dft.parse(startDate);    //开始时间
        Date endDay = dft.parse(endDate);       //结束时间
        Long starTime = starDay.getTime();
        Long endTime = endDay.getTime();
        Long num = endTime - starTime;//时间戳相差的毫秒数
        Long days = num / (24 * 60 * 60 * 1000);
        return new Long(days).intValue();
    }

    public int getIntervalDays(Date startDay,Date endDay){
        Long starTime = startDay.getTime();
        Long endTime = endDay.getTime();
        Long num = endTime - starTime;//时间戳相差的毫秒数
        Long days = num / (24 * 60 * 60 * 1000);
        return new Long(days).intValue();
    }

    public String getTheDateByMonth(int months) {
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        Date date = new Date();
        Calendar calendar = Calendar.getInstance();
        // 设置为当前时间
        calendar.setTime(date);
        calendar.add(Calendar.MONTH, -months);
        // 设置为上一个月
        //calendar.set(Calendar.MONTH, calendar.get(Calendar.MONTH) - 1);
        date = calendar.getTime();
        return format.format(date);
    }

    public String getTheMonthFirstDay(Date newDate) {
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(newDate);
//        calendar.add(Calendar.MONTH, -1);
        calendar.set(Calendar.DAY_OF_MONTH, 1);
//        System.out.println("上个月第一天："+format.format(calendar.getTime()));
        return format.format(calendar.getTime());
    }

    public String getTheMonthEndDay(Date newDate) {
        SimpleDateFormat sf = new SimpleDateFormat("yyyy-MM-dd");
        Calendar calendar1 = Calendar.getInstance();
        calendar1.setTime(newDate);
        int month = calendar1.get(Calendar.MONTH);
//        calendar1.set(Calendar.MONTH, month - 1);
        calendar1.set(Calendar.DAY_OF_MONTH, calendar1.getActualMaximum(Calendar.DAY_OF_MONTH));
//        System.out.println("上个月最后一天："+sf.format(calendar1.getTime()));
        return sf.format(calendar1.getTime());
    }

    public int getNowHour() {
        Calendar cal = Calendar.getInstance();
        return cal.get(Calendar.HOUR_OF_DAY);
    }

    public int setCalendarNewTime(String newTime) throws ParseException {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss:SSS");
        Calendar cal = Calendar.getInstance();
        cal.setTime(sdf.parse(newTime));
        return cal.get(Calendar.HOUR_OF_DAY);
    }

    public int setCalendarNewTime(Timestamp newTime) throws ParseException {
        Calendar cal = Calendar.getInstance();
        cal.setTime(newTime);
        return cal.get(Calendar.HOUR_OF_DAY);
    }

    //格式化日期(Long --> Date)
    public String formatLongToDate(Long longDate) {
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date date = new Date(longDate);
        return df.format(date);
    }

    //格式化本年
    public String getThisYear() {
        Calendar cal = Calendar.getInstance();
        int year = cal.get(Calendar.YEAR);
        return String.valueOf(year);
    }

    //获取本月
    public String getThisMonth() {
        Calendar cal = Calendar.getInstance();
        int month = cal.get(Calendar.MONTH) + 1;
        if (String.valueOf(month).length() == 1) {
            return "0" + String.valueOf(month);
        } else {
            return String.valueOf(month);
        }
    }

    //格式化本月
    public String getLastMonth() {
        Calendar cal = Calendar.getInstance();
        cal.add(Calendar.MONTH, -1);
        int month = cal.get(Calendar.MONTH) + 1;
        if (String.valueOf(month).length() == 1) {
            return "0" + String.valueOf(month);
        } else {
            return String.valueOf(month);
        }
    }

    //格式化本月
    public String getLastMonthAndYear(Date date) {
        Calendar cal = Calendar.getInstance();
        cal.setTime(date);
        cal.add(Calendar.MONTH, -1);
        int month = cal.get(Calendar.MONTH) + 1;
        int year = cal.get(Calendar.YEAR);
        return year + "-" + month;
    }

    //格式化日期时间
    public String formatDateTime(String dateText) throws ParseException {
        if (dateText.indexOf("T") != -1) {
            dateText = dateText.replace("T", " ");
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date date = sdf.parse(dateText);
        return sdf.format(date);
    }

    //格式化日期时间
    public String formatDateText(String dateText) throws ParseException {
        if (dateText.indexOf("T") != -1) {
            dateText = dateText.replace("T", " ");
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Date date = sdf.parse(dateText);
        return sdf.format(date);
    }
//    public String formatDateText(Date date) throws ParseException {
//        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
//        return sdf.format(date);
//    }

    public Date parseDateTime(String dateText) throws ParseException {
        if (dateText.indexOf("T") != -1) {
            dateText = dateText.replace("T", " ");
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return sdf.parse(dateText);
    }

    public Date parseDate(String dateText) throws ParseException {
        if (dateText.indexOf("T") != -1) {
            dateText = dateText.replace("T", " ");
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        return sdf.parse(dateText);
    }

    public Long parseDateTimeTextToLong(String dateText) throws ParseException {
        if (dateText.indexOf("T") != -1) {
            dateText = dateText.replace("T", " ");
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date date = sdf.parse(dateText);
        return date.getTime();
    }

    public Long parseDateTextToLong(String dateText) throws ParseException {
        if (dateText.indexOf("T") != -1) {
            dateText = dateText.replace("T", " ");
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Date date = sdf.parse(dateText);
        return date.getTime();
    }

    //
    public Date getTodayDate() throws ParseException {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        return sdf.parse(sdf.format(new Date()));
    }

    public Date getTodayDatetime() throws ParseException {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return sdf.parse(sdf.format(new Date()));
    }

    public String getTodayDateText() throws ParseException {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        return sdf.format(new Date());
    }

    public java.sql.Date getTodayMySQLDate() {
        java.sql.Date todayDate = new java.sql.Date(new Date().getTime());
        return todayDate;
    }

    public Timestamp getTimestamp() {
        Timestamp nowTimestamp = new Timestamp(new Date().getTime());
        return nowTimestamp;
    }

    public String getTodayText() throws ParseException {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return sdf.format(new Date());
    }

    public String formatDateText(Date date) throws ParseException {
        if (date == null) {
            return "";
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        return sdf.format(date);
    }

    public String formatDatetimeText(Date date) throws ParseException {
        if (date == null || date.toString().length() == 0) {
            return "";
        }
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        return sdf.format(date);
    }

    public String getNowText() throws ParseException {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        return sdf.format(new Date());
    }

    public String getTodayMissionText() throws ParseException {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS");
        return sdf.format(new Date());
    }

    public String getStartDateInThisMonth() {
        DateTime date = cn.hutool.core.date.DateUtil.date();
        return (cn.hutool.core.date.DateUtil.beginOfMonth(date) + "").substring(0, 10);
    }

    public String getEndDateInThisMonth() {
        DateTime date = cn.hutool.core.date.DateUtil.date();
        return (date + "").substring(0, 10);
    }

    public String get(int beforeMonths) {
        DateUtil dateUtil = new DateUtil();
        Calendar cal = Calendar.getInstance();
        cal.setTime(new Date());
        cal.set(Calendar.DAY_OF_MONTH, 1);
//        System.out.println (new SimpleDateFormat("yyyy-MM-dd").format(cal.getTime()));
        cal.roll(Calendar.DAY_OF_MONTH, -1);
//        System.out.println (new SimpleDateFormat("yyyy-MM-dd").format(cal.getTime()));
        return new SimpleDateFormat("yyyy-MM-dd").format(cal.getTime());
    }

    public String getThisMonthFirstDay() {
        DateUtil dateUtil = new DateUtil();
        Calendar cal = Calendar.getInstance();
        cal.setTime(new Date());
        cal.set(Calendar.DAY_OF_MONTH, 1);
//        System.out.println (new SimpleDateFormat("yyyy-MM-dd").format(cal.getTime()));
        return new SimpleDateFormat("yyyy-MM-dd").format(cal.getTime());
//        cal.roll(Calendar.DAY_OF_MONTH, -1);
//        System.out.println (new SimpleDateFormat("yyyy-MM-dd").format(cal.getTime()));
    }

    public String getThisMonthEndDay() {
        DateUtil dateUtil = new DateUtil();
        Calendar cal = Calendar.getInstance();
        cal.setTime(new Date());
        cal.set(Calendar.DAY_OF_MONTH, 1);
//        System.out.println (new SimpleDateFormat("yyyy-MM-dd").format(cal.getTime()));
        cal.roll(Calendar.DAY_OF_MONTH, -1);
//        System.out.println (new SimpleDateFormat("yyyy-MM-dd").format(cal.getTime()));
        return new SimpleDateFormat("yyyy-MM-dd").format(cal.getTime());
    }

    public String getLastMonthFirstDay() {
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        Calendar calendar = Calendar.getInstance();
        calendar.add(Calendar.MONTH, -1);
        calendar.set(Calendar.DAY_OF_MONTH, 1);
//        System.out.println("上个月第一天："+format.format(calendar.getTime()));
        return format.format(calendar.getTime());
    }

    public String getLastMonthEndDay() {
        SimpleDateFormat sf = new SimpleDateFormat("yyyy-MM-dd");
        Calendar calendar1 = Calendar.getInstance();
        int month = calendar1.get(Calendar.MONTH);
        calendar1.set(Calendar.MONTH, month - 1);
        calendar1.set(Calendar.DAY_OF_MONTH, calendar1.getActualMaximum(Calendar.DAY_OF_MONTH));
//        System.out.println("上个月最后一天："+sf.format(calendar1.getTime()));
        return sf.format(calendar1.getTime());
    }

    /**
     * 获取过去或者未来 任意天内的日期数组
     *
     * @param intervals intervals天内
     * @return 日期数组
     */
    public ArrayList<String> test(int intervals) {
        ArrayList<String> pastDaysList = new ArrayList<>();
        ArrayList<String> fetureDaysList = new ArrayList<>();
        for (int i = 0; i < intervals; i++) {
            pastDaysList.add(getPastDate(i));
            fetureDaysList.add(getFetureDate(i));
        }
        return pastDaysList;
    }

    /**
     * @Method : getPastIntervals
     * @Description : 返回过去N天日期(倒排序)
     * @Params : [intervals]
     * @Return : java.util.ArrayList<java.lang.String>
     * @Author : ZhuoNing
     * @Date : 2022/3/7
     * @Time : 15:27
     */
    public ArrayList<String> getPastIntervals(int intervals) {
        ArrayList<String> pastDaysList = new ArrayList<>();
        for (int i = 0; i < intervals; i++) {
            pastDaysList.add(getPastDate(i));
        }
        return pastDaysList;
    }

    /**
     * @Method : getPastIntervalsASC
     * @Description : 正排序
     * @Params : [intervals]
     * @Return : java.util.ArrayList<java.lang.String>
     * @Author : ZhuoNing
     * @Date : 2022/3/7
     * @Time : 16:33
     */
    public ArrayList<String> getPastIntervalsASC(int intervals) {
        ArrayList<String> pastDaysList = new ArrayList<>();
        for (int i = intervals - 1; i >= 0; i--) {
            pastDaysList.add(getPastDate(i));
        }
        return pastDaysList;
    }

    /**
     * @Method : getFetureIntervals
     * @Description : 获取未来N天日期
     * @Params : [intervals]
     * @Return : java.util.ArrayList<java.lang.String>
     * @Author : ZhuoNing
     * @Date : 2022/3/7
     * @Time : 15:28
     */
    public ArrayList<String> getFetureIntervals(int intervals) {
        ArrayList<String> fetureDaysList = new ArrayList<>();
        for (int i = 0; i < intervals; i++) {
            fetureDaysList.add(getFetureDate(i));
        }
        return fetureDaysList;
    }


    /**
     * 获取过去第几天的日期
     *
     * @param past
     * @return
     */
    public String getPastDate(int past) {
        Calendar calendar = Calendar.getInstance();
        calendar.set(Calendar.DAY_OF_YEAR, calendar.get(Calendar.DAY_OF_YEAR) - past);
        Date today = calendar.getTime();
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        String result = format.format(today);
        return result;
    }

    /**
     * 获取未来 第 past 天的日期
     *
     * @param past
     * @return
     */
    public String getFetureDate(int past) {
        Calendar calendar = Calendar.getInstance();
        calendar.set(Calendar.DAY_OF_YEAR, calendar.get(Calendar.DAY_OF_YEAR) + past);
        Date today = calendar.getTime();
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        String result = format.format(today);
        return result;
    }

    //重新构建日期
    public String rebuildDateTime(String text) {
        return text.substring(0, 4) + "-" + text.substring(4, 6) + "-" + text.substring(6, 8) + " " + text.substring(8, 10) + ":" + text.substring(10, 12) + ":" + text.substring(12, 14);
    }

    public static void main(String[] args) {
        DateUtil du = new DateUtil();
        //
//        du.test1();
        List<String> pastList = du.getPastIntervalsASC(5);
        for (String pastDate : pastList) {
            System.out.println("pastDate>>" + pastDate);
        }

        List<String> fetureList = du.getFetureIntervals(5);
        for (String fetureDate : fetureList) {
            System.out.println("fetureDate>>" + fetureDate);
        }

    }

    private void test1() {
        String text = "20211201104300";
//        String text = "1234567890abcd";
        String date = text.substring(0, 4) + "-" + text.substring(4, 6) + "-" + text.substring(6, 8) + " " + text.substring(8, 10) + ":" + text.substring(10, 12) + ":" + text.substring(12, 14);
        System.out.println("date=" + date);
    }

    //获取long时间
    public Long getNowLong() {
        Calendar calendar = Calendar.getInstance();
        calendar.set(calendar.get(Calendar.YEAR), calendar.get(Calendar.MONTH), calendar.get(Calendar.DAY_OF_MONTH) - 1, 0, 0, 0);
        return calendar.getTime().getTime();
    }

    public Date getPastDate(Date date1, int past) {
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date1);
        calendar.set(Calendar.DAY_OF_YEAR, calendar.get(Calendar.DAY_OF_YEAR) - past);
        Date newDate = calendar.getTime();
        return newDate;
//        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
//        return format.parse(newDate);
    }

    public Date getFetureDate(Date date1, int days) {
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date1);
        calendar.set(Calendar.DAY_OF_YEAR, calendar.get(Calendar.DAY_OF_YEAR) + days);
        return calendar.getTime();
    }

    public String getTheMonthByDate(String dateText) throws ParseException {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM");
        Date date = sdf.parse(dateText);
        return sdf.format(date);
    }
}
